=== debian/changelog ===
cryptominisat (5.6.4+dfsg.1-1ubuntu1) disco; urgency=medium

  * Build against default boost.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 13 Nov 2018 17:03:39 +0000

cryptominisat (5.6.4+dfsg.1-1) unstable; urgency=low

  * Initial release. Stripped the upstream tarball of parts of the non-free
    docs/ directory. Closes: #905391

 -- Julian Rüth <julian.rueth@fsfe.org>  Tue, 28 Aug 2018 20:21:40 -0700
