=== debian/control ===
Source: cryptominisat
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Julian Rüth <julian.rueth@fsfe.org>
Build-Depends: cmake, debhelper (>=10.2.1), dh-python, python3-dev, libboost-program-options-dev, libm4ri-dev, zlib1g-dev
Standards-Version: 4.1.5
Homepage: https://www.msoos.org/
Vcs-Git: https://github.com/msoos/cryptominisat.git
Vcs-Browser: https://github.com/msoos/cryptominisat
X-Python3-Version: >= 3.6

Package: libcryptominisat5-5.6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}, libm4ri-0.0.20140914, zlib1g
Description: SAT solver library
 CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
 .
 This package provides a shared library to link against the CryptoMiniSat
 library.

Package: cryptominisat
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SAT solver command line interface
 CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
 .
 This package provides a command line interface which reads SAT formulas in
 conjunctive normal form in the DIMACS format with the extension of XOR
 clauses and decides whether they are satisfiable.

Package: python3-cryptominisat
Architecture: any
Multi-Arch: same
Section: python
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Description: Python bindings for the CryptoMiniSat SAT solver (Python 3)
 CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
 .
 This package provides the pycroptosat module to use CryptoMiniSat from Python
 3. See https://github.com/msoos/cryptominisat#python-usage for examples.

Package: libcryptominisat5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libcryptominisat5-5.6 (= ${binary:Version})
Description: development files for the CryptoMiniSat SAT solver
 CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
 .
 This package provides C++ header files to interface with CryptoMiniSat. See
 https://github.com/msoos/cryptominisat#library-usage for some examples. This
 package also includes the experimental cryptominisat_c.h header to interface
 with CryptoMiniSat from C.
