## cryptominisat 5.7.1+dfsg1

=== debian/changelog ===
cryptominisat (5.7.1+dfsg1-1) unstable; urgency=medium

  * New upstream release 5.7.1.
  * Add myself to the packaging.
  * Point Vcs-* fields to salsa.
  * Update deps (Closes: #915605, #954895).
  * Fix typo in description (Closes: #931284).
  * Drop the symbols file (Closes: #913390, #914711).
  * Drop d/compat and use dh-compat 12.
  * Bump std-ver to 4.5.0.
  * Reworked d/copyright.
  * Ship upstream manpages.
  * Add links from versioned executables to unversioned.
  * Update d/copyright's Files-Excluded to new upstream.
  * Improve d/watch.
  * Drop DEB_LDFLAGS_MAINT_APPEND from d/rules: its value
    is now default.
  * Add help2man to b-deps.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 08 May 2020 10:55:25 +0200
