=== debian/control ===
--- 
+++ 
@@ -1,21 +1,19 @@
 Source: cryptominisat
 Section: math
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Julian Rüth <julian.rueth@fsfe.org>
-Build-Depends: cmake, debhelper (>=10.2.1), dh-python, python3-dev, libboost-program-options-dev, libm4ri-dev, zlib1g-dev
-Standards-Version: 4.1.5
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Julian Rüth <julian.rueth@fsfe.org>, Julien Puydt <jpuydt@debian.org>
+Build-Depends: cmake, debhelper-compat (=12), dh-python, help2man, python3-dev, libboost-program-options-dev, libm4ri-dev, zlib1g-dev
+Standards-Version: 4.5.0
 Homepage: https://www.msoos.org/
-Vcs-Git: https://github.com/msoos/cryptominisat.git
-Vcs-Browser: https://github.com/msoos/cryptominisat
-X-Python3-Version: >= 3.6
+Vcs-Git: https://salsa.debian.org/science-team/cryptominisat.git
+Vcs-Browser: https://salsa.debian.org/science-team/cryptominisat
 
-Package: libcryptominisat5-5.6
+Package: libcryptominisat5-5.7
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${misc:Depends}, ${shlibs:Depends}, libm4ri-0.0.20140914, zlib1g
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: SAT solver library
  CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
  .
@@ -42,7 +40,7 @@
 Description: Python bindings for the CryptoMiniSat SAT solver (Python 3)
  CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
  .
- This package provides the pycroptosat module to use CryptoMiniSat from Python
+ This package provides the pycryptosat module to use CryptoMiniSat from Python
  3. See https://github.com/msoos/cryptominisat#python-usage for examples.
 
 Package: libcryptominisat5-dev
@@ -50,7 +48,7 @@
 Multi-Arch: same
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, libcryptominisat5-5.6 (= ${binary:Version})
+Depends: ${misc:Depends}, libcryptominisat5-5.7 (= ${binary:Version})
 Description: development files for the CryptoMiniSat SAT solver
  CryptoMiniSat is a modern, multi-threaded, simplifying SAT solver.
  .
